unit uVr2Memo;

{*** Oplossing vraag 2 ***}

interface

TYPE
   TData = class(TObject)
     private
        fGNaam       : String;
        fDNaam       : String;
        fMNaam       : String;
        fAantD       : Integer;
        fAantT       : Integer;
        fTarief      : Real;
     public
         function getGNaam : String;
         function getDNaam : String;
         function getMNaam : String;
         function getAantD  : Integer;
         function getAantT  : Integer;
         function getTarief: Real;

         constructor Create(sGids, sBestemming, sMaand: String; iDae, iAantal : Integer);
         procedure setTarief;
         function verkortString : String;
         function vindGelukKarak : Char;
         function toString : String;
     end;


implementation

uses SysUtils;

{ TData }

constructor TData.Create(sGids, sBestemming, sMaand: String; iDae,
  iAantal: Integer);
begin
   fGNaam       := sGids;
   fDNaam       := sBestemming;
   fMNaam       := sMaand;
   fAantD       := iDae;
   fAantT       := iAantal;
   SetTarief;
end;

procedure TData.setTarief;
var
   sMaand : String;
begin
   sMaand := Uppercase(fMNaam);
   iF (sMaand = 'APRIL') OR (sMaand = 'SEPTEMBER') OR
      (sMaand = 'DESEMBER')
    then
       fTarief := 1250.00
    else
     iF (sMaand = 'MAART') OR (sMaand = 'MEI') OR
      (sMaand = 'JUNIE') OR (sMaand = 'JULIE')
     then
        fTarief := 900.00
     else
        fTarief := 1000.00;
end;

function TData.verkortString: String;
var
   a : Integer;
   sTemp  : String;
begin
   sTemp := fMNaam[1];
   for a := 2 to length(fMNaam) do
    if NOT(Upcase(fMNaam[a]) in ['A','E','I','O','U'])
     then sTemp := sTemp + fMNaam[a];

   Result := sTemp;
end;

function TData.vindGelukKarak: Char;
var
 iMax, iLuckyNum : Integer;
begin
  iMax := length(fDNaam);
  Repeat
    iLuckyNum := random(iMax)+1;
  Until fDNaam[iLuckyNum] <> #32;

  Result := fDNaam[iLuckyNum];
end;

function TData.toString: String;
begin
   Result := 'Maand: ' + verkortString + #13 +
             'Bestemming: ' + fDNaam + ' met ' + fGNaam + ' as die toergids ' + #13 +
             'Prys: ' + FloatToStrF(fTarief, ffCurrency, 9,2) +
             ' per dag vir ''n tydperk van '+ IntToStr(fAantD) + ' dae'+ #13 +
              IntToStr(fAantT) + ' toeriste gaan op hierdie toer.';
end;

function TData.getAantD: Integer;
begin
    result := fAantD;
end;

function TData.getAantT: Integer;
begin
    result := fAantT;
end;

function TData.getGNaam: String;
begin
  Result := fGNaam;
end;

function TData.getDNaam: String;
begin
  Result := fDNaam;
end;

function TData.getMNaam: String;
begin
   Result := fMNaam;
end;

function TData.getTarief: Real;
begin
  Result := fTarief
end;

end.
